//*****************************************************************
// Questo libreria si occupa di implementare la funzione di una 
// unit di controllo all'interno di un una macchina tipo quella di 
// Von Neumann e rappresenta dunque il cuore vero e proprio di 
// tutto il sistema.
//
// Nome del progetto     : control_unit.h control_unit.cpp
// Creatore              : Giovanni Ceglia
// Data ultima revisione : 16/05/2001
//
// Librerie e files richiesti:    io_unit.h io_unit.cpp
//                                vmachine.h vmachine.cpp
//                                tplus.h tplus.cpp
//                                alu_unit.h alu_unit.cpp
//*****************************************************************

#include "tplus.h"         // libreria che contiene implementazioni
                           // di tipi nuovi, come quello stringa
                           // oppure il tipo boolean e relative 
                           // funzioni utili alla gestione.
                           
#include "vmachine.h"      // libreria che implementa la macchina virtuale

#include "alu_unit.h"      // simulazione della ALU
#include "io_unit.h"       // unita di input output

#if ! defined (CONTROLUNIT)
#define CONTROLUNIT
 
// funzione che va in ciclo e che simula il funzionamento vero e prioprio di
// una ipotetica unit di controllo.
extern void unita_di_controllo(virtual_machine&);

// fase di caricamento e di preparazione all'esecuzione della prossima 
// istruzione
extern void fase_fetch(virtual_machine&);

// esecuzione dell'istruzione prelevata dalla memoria
extern void fase_execute(virtual_machine&);

// unit specifica che si occupa di implementare ed eseguire
// le funzioni proprie dell ' unit di controllo.
extern void uc_exec(virtual_machine&);

#endif
