//*****************************************************************
// Questo programma si occupa di gestire e realizzare la 
// trasformazione di un codice sorgente in un codice macchina.
// la trasformazione avviene trasformando un particolare tipo
// di codice sorgente che rappresenta la codifica in codici 
// mnemonici di programmi per il simulatore di Von Neumann 
// realizzato.
//
// Nome del progetto     : Compiler files
// Nome di questo file   : loader.cpp
// Altri files associati : tplus.cpp tplus.h 
//                         translater.cpp translater.h
//                         vmachine.cpp vmachine.h
// 
// Creatore              : Giovanni Ceglia 
// Data ultima revisione : 22/05/2003
// Per contatti          : giovanniceglia@email.it 
//*****************************************************************

#include <iostream.h>
#include "tplus.h"
#include "vmachine.h"
#include "translater.h"

int main(int argc, char *argv[])
{
 cout<<"\n";
 cout<<"***************************************************************************"<<"\n";
 cout<<"*                                                                         *"<<"\n";
 cout<<"*    Assemblatore/Compilatore per Ceglia Virtual Machine - Versione 1.1   *"<<"\n";
 cout<<"*                                                                         *"<<"\n";
 cout<<"*    Simulatore di una ipotetica Macchina di Von Neumann. Versione 1.1    *"<<"\n";
 cout<<"*                                                                         *"<<"\n";
 cout<<"*    Autore -> Giovanni Ceglia  giovanniceglia@xungame.com                *"<<"\n";
 cout<<"*                                                                         *"<<"\n";
 cout<<"*    Sito Web dell'autore -> http://www.xungame.com/                      *"<<"\n"; 
 cout<<"*                                                                         *"<<"\n";
 cout<<"*    Ultima revisione 22/05/2003 - Versione non esente da difetti.        *"<<"\n";
 cout<<"*                                                                         *"<<"\n";
 cout<<"***************************************************************************"<<"\n";
 cout<<"\n";
 if ((argv[1]==NULL) || (argv[2]==NULL))
   {
    cout<<" Numero di parametri insufficienti."<<"\n";
    cout<<" E' necesaria la seguente sintassi : compiler <sourcefile> <destfile>"<<"\n";
    cout<<"\n";
   }
  else
   { 
    cout<<" programma in fase di compilazione..."<<"\n";
    cout<<" numero di bytes generati : "<<int(genera_programma(argv[1],argv[2]))<<"\n";
    cout<<" compilazione terminata con successo."<<"\n";
   } 
 return 0;  
}

