//*****************************************************************
// Questo software  una simulazione del modello di macchina 
// automatica di Von Neumann.  
//
// Nome del progetto     : vonneum
// Creatore              : Giovanni Ceglia
// Data ultima revisione : 22/05/2003
//
// Librerie di sistema richieste:
// <conio>
// <iostream>
// <stdio>
//
// Librerie esterne non di sistema richieste:
//
// alu_unit.h, alu_unit.o <obj/coff> o in alternativa alu_unit.cpp
// control_unit.h, control_unit.o <obj/coff> o in alternativa control_unit.cpp
// io_unit.h, io_unit.o <obj/coff> o in alternativa io_unit.cpp
// tplus.h, tplus.o <obj/coff> o in alternativa tplus.cpp
// vmachine.h, vmachine.o <obj/coff> o in alternativa vmachine.cpp
// simul.cpp che  il programma che collega ed avvia il tutto.
//
//
// NOTA: *<obj> dipende dal compilatore che si intende 
// utilizzare, questo simulatore  stato realizzato con DevC++ 
// il quale utilizza per i file oggetto precompilati 
// l ' estensione .o ( dovrebbe avere qualcosa a che fare 
// con il formato .coff ) se invece ad esempio si  dovesse 
// utilizzare il C++ Builder della Borland, oppure Visual C++
// di Microsoft i file oggetto vengono chiamati .obj, altri 
// compilatori potrebbero utilizzare altre convenzioni.
//
// Il seguente software consta inoltre del file di specifiche
// per ulteriore documentazione sul suo funzionamento.
//
// specifiche.txt
//
//*****************************************************************
                                       
#include <iostream.h>      // libreria di sistama.
#include "vmachine.h"      // libreria che definisce la macchina virtuale.
#include "control_unit.h"  // libreria che simula l'unit centrale.

// funzione di avvio della simulazione.
int main(int argc, char *argv[])
 {
  cout<<"\n";
  cout<<"***************************************************************************"<<"\n";
  cout<<"*                                                                         *"<<"\n";
  cout<<"*    Ceglia Virtual Machine - Versione 1.1                                *"<<"\n";
  cout<<"*                                                                         *"<<"\n";
  cout<<"*    Simulatore di una ipotetica Macchina di Von Neumann. Versione 1.1    *"<<"\n";
  cout<<"*                                                                         *"<<"\n";
  cout<<"*    Autore -> Giovanni Ceglia  giovanniceglia@xungame.com                *"<<"\n";
  cout<<"*                                                                         *"<<"\n";
  cout<<"*    Sito Web dell'autore -> http://www.xungame.com/                      *"<<"\n"; 
  cout<<"*                                                                         *"<<"\n";
  cout<<"*    Ultima revisione 22/05/2003 - Versione non esente da difetti.        *"<<"\n";
  cout<<"*                                                                         *"<<"\n";
  cout<<"***************************************************************************"<<"\n";
  cout<<"\n";
  if (argv[1]==NULL)
    {
     cout<<" Numero di parametri insufficienti."<<"\n";
     cout<<" E' necesaria la seguente sintassi : vonneum <programma> "<<"\n";
     cout<<"\n";
    }
   else
    { 
     cout<<" Avvio della macchina virtuale simulata..."<<"\n";
     // creazione di una macchina virtuale per la simulazione.
     virtual_machine von_neumann;
     cout<<" Caricamento del programma ("<<argv[1]<<") da eseguire... "<<"\n";
     // caricamento del programma precompilato.
     carica_programma(argv[1], von_neumann);
     cout<<" Esecuzione del codice avviata... "<<"\n";
     cout<<"\n";
     // il controllo passa alla CU (control unit).
     unita_di_controllo(von_neumann);
     cout<<"\n";
     cout<<"\n";
     cout<<" La Macchina virtuale e' stata spenta con istruzione di RESET."<<"\n";
     cout<<" Per eseguire un altro programma riavvia la Macchina."<<"\n";
     cout<<"\n";
    } 
  return 0;   
 }


