//*****************************************************************
// Questa libreria si occupa di implementare le funzioni utili
// alla gestione di alcuni tipi come quello stringa o boolean
// necessari per una migliore implementazione di vari programmi.
//
// Nome del progetto     : tplus.h tplus.cpp
// Creatore              : Giovanni Ceglia
// Data ultima revisione : 16/05/2001
//*****************************************************************
 
typedef char string81[81];    // definizione di un tipo stringa

struct testo{               // definizione di un tipo strutturat
  string81 riga[100];         // chiamato testo e che rappresenta un
  unsigned char count;      // testo, cio un insieme di stringhe.
 };

// effettua la potenza di n elevato ad exp
int potenza(const int n, const int exp);

// restituisce il valore intero positivo di una cifra numerica
unsigned char cifra(const char ch);

// restituisce la dimensione di una qualunque stringa asciz 
// cioe' una stringa chiusa da zero.
int strsize(const string81 s);

// dice se un carattere rappresenta una cifra decimale.
bool cifra_dec(const char ch);

//dice se una stringa rappresenta un numero decimale.
bool numero_dec(const string81);

// converte un valore da una rappresentazione come stringa
// in una rappresentazione come intero.
unsigned char strint(const string81 s);

// effettua il confronto fra due stringhe.
extern bool ceglia_strcmp(const string81, const string81);


// implementazione delle funzioni sopra descritte.

bool ceglia_strcmp(const string81 s1, const string81 s2)
 {
  int siz1,siz2,i;
  siz1=strsize(s1);
  siz2=strsize(s2);
  if (siz1 != siz2) return false;
   else {
         for (i=0; i<siz1; i++) 
           if (s1[i]!=s2[i]) return false;
        }
  return true;  
 }

int potenza(const int n, const int exp)
  {
    if (exp==0) return 1;
     else return (n * potenza(n,exp-1));
  }

unsigned char cifra(const char ch)
  {
    return (ch-48);
  }

int strsize(const string81 s)
  {
    int i=0;
    while (s[i]!=0) i++;
    return i;
  }

bool cifra_dec(const char ch)
 {
  if ((ch>=48) && (ch<58)) return true;
   else return false;
 }

bool numero_dec(const string81 s)
 {
  int len,i;
  len=strsize(s);
  i=0;
  if ((s[0]=='+')||(s[0]=='-')) i++;
  while (i<len) {
    if (cifra_dec(s[i])!=true) return false;
    i++;
   } 
  return true;
 }

unsigned char strint(const string81 s)
  {
    int i,strsiz,valore;
    strsiz=strsize(s);
    valore=0;
    i=0;
    if ((s[0]=='+')||(s[0]=='-')) i++;
    while (i<strsiz) {
      valore=valore+(cifra(s[i])*potenza(10,strsiz-i-1));
      i++;
     } 
    if (s[0]=='-') valore=256-valore;
    return valore;
  }



